#include <LiquidCrystal.h>//библиотека для работы с LCD
#include <BH1750FVI.h> // Sensor Library
#include <Wire.h> // I2C Library
#include <SPI.h>         
#include <Ethernet.h>
#include <EthernetClient.h>
#include <EthernetServer.h>
#include <EthernetUdp.h>
#define REQUEST_RATE 300000 // milliseconds

byte mac[] = {  
  0x00, 0x08, 0xDC, 0xBD, 0x24, 0xFF };

unsigned int localPort = 8888;      // local port to listen for UDP packets

IPAddress main_server(192,168,0,113);
IPAddress narodmonserver(94,19,113,221);
IPAddress timeServer(132, 163, 4, 101); // time-a.timefreq.bldrdoc.gov NTP server
// IPAddress timeServer(132, 163, 4, 102); // time-b.timefreq.bldrdoc.gov NTP server
// IPAddress timeServer(132, 163, 4, 103); // time-c.timefreq.bldrdoc.gov NTP server

const int NTP_PACKET_SIZE= 48; // NTP time stamp is in the first 48 bytes of the message

byte packetBuffer[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets 

// A UDP instance to let us send and receive packets over UDP
EthernetUDP Udp;
EthernetClient report;

 long previousMillis = 0;//переменная для хранения значений таймера
 
 int sek=0;//значение секунд
 int sek2=5;
 int min=0;//значение минут
 int light = 0;
 int chas=0;//значение часов
 int knopka=0;//значение кнопки
 int zd=5;
 int stat = 0;
 static long timer;

LiquidCrystal lcd(24, 25, 26, 27, 28, 29, 30);//инициализация портов
uint16_t Light_Intensity=0;

BH1750FVI LightSensor;

String macstring;


void setup()
{
 macstring="";
  for(int k=0;k<sizeof(mac)/sizeof(byte);k++)
  {
        char msg[3];
        sprintf(msg,"%02X",mac[k]);
        //if (macstring!="#") macstring+="-";
        macstring+=msg;
  }
  
 lcd.begin(20, 2);//иницифлизация дисплея
 //pinMode(8,INPUT);//инициализация портов
 //pinMode(9,OUTPUT);//инициализация портов
 pinMode(9, OUTPUT);
 pinMode(10, OUTPUT);
 pinMode(13,OUTPUT);//инициализация портов
 LightSensor.begin();
 LightSensor.SetAddress(Device_Address_H); //Address 0x5C
 LightSensor.SetMode(Continuous_H_resolution_Mode);
 
  // start Ethernet and UDP
  dhcp:
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Get ip by DHCP..");
  if (Ethernet.begin(mac) == 0) {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Fail conf using DHCP");
    // no point in carrying on, so do nothing forevermore:
    delay(10000);
    goto dhcp;
  }
  
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("    Succsses");
  lcd.setCursor(0, 1);
  lcd.print(" ip:");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    // print the value of each byte of the IP address:
    lcd.print(Ethernet.localIP()[thisByte], DEC);
    lcd.print("."); 
  }
  delay(1000);
  Udp.begin(localPort);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Send NTP Pac");
  sendNTPpacket(timeServer); // send an NTP packet to a time server
  lcd.setCursor(0, 0);
  lcd.print("Wait for NTP relay");
    // wait to see if a reply is available
  delay(1000);  
  if ( Udp.parsePacket() ) {  
    
  lcd.setCursor(0, 0);
    // We've received a packet, read the data from it
    Udp.read(packetBuffer,NTP_PACKET_SIZE);  // read the packet into the buffer

    //the timestamp starts at byte 40 of the received packet and is four bytes,
    // or two words, long. First, esxtract the two words:

    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    unsigned long lowWord = word(packetBuffer[42], packetBuffer[43]);  
    // combine the four bytes (two words) into a long integer
    // this is NTP time (seconds since Jan 1 1900):
    unsigned long secsSince1900 = highWord << 16 | lowWord;   
    lcd.setCursor(0, 0);
    // now convert NTP time into everyday time:
    lcd.print("Unix time = ");
    // Unix time starts on Jan 1 1970. In seconds, that's 2208988800:
    const unsigned long seventyYears = 2208988800UL;     
    // subtract seventy years:
    unsigned long epoch = secsSince1900 - seventyYears;  
    // print Unix time:
    lcd.println(epoch);                               
    chas = ((epoch  % 86400L) / 3600);
    if(chas>20) {
      chas=chas-21;
    }
    else {
      chas=chas+3;  
    }
    min = (epoch  % 3600) / 60; 
    sek = epoch %60;
  }
  
  lcd.clear(); //обновление дисплея
  timer = - REQUEST_RATE;
}

void loop()
{
 if (millis() - previousMillis >500) 
 {  
   previousMillis = millis();  //запучкаем таймер
   digitalWrite(13, !digitalRead(13));//меняем значение порта каждые 0.5секунд
   
   
   
   
   if(digitalRead(13)==HIGH)//если 13 нога лог1 то...
   {
     sek++;//переменная секунда + 1
     //lcd.clear(); //обновление дисплея
     sek2++;
     
     
     
     //вывод символов на дисплей//
     lcd.setCursor(2+zd, 1);
     lcd.print(":");//выводим символ ":"между часами и минутами
     lcd.setCursor(5+zd, 1);
     lcd.print(":");//выводим символ ":"между  минутами и секундами
   }
   
   if(digitalRead(13)==LOW)
   {
     //через каждые 0.5 секунд меняем символ ":" на "."
     lcd.setCursor(5+zd, 1);
     lcd.print(" ");
   }
   
   if(sek2>3)//если переменная секунда больше 59 ...
   {
     Light_Intensity=LightSensor.GetLightIntensity();
     lcd.setCursor(1, 0);
     lcd.print(Light_Intensity);
     lcd.print(" Lux   ");
     lcd.setCursor(11, 0);
     lcd.print("li:");
     lcd.print(light);
     sek2=0;
     report.stop();
   }
   
   if(sek>59)//если переменная секунда больше 59 ...
   {
     sek=0;//сбрасываем ее на 0
     min++;//пишем +1 в переменную минута
     lcd.setCursor(2+zd, 1);
     lcd.print(" ");
   }
   
   
   if(min>59)//если переменная минута больше 59 ...
   {
     min=0;//сбрасываем ее на 0
     chas++;//пишем +1 в переменную час
   }
   
   if(millis() > timer + REQUEST_RATE)
   {
     
     stat=report.connect(main_server, 82);
     if (stat)
     {
     timer = millis();
     report.print("GET ");
     report.print("/objects/?object=mt_controller&op=m&m=status_update&lux=");

     //report.print("POST http://narodmon.ru/post.php HTTP/1.0\r\n Host: narodmon.ru\r\nContent-Length: ");
     //report.print("\r\n\r\n");
     //report.print("ID=");
     //report.print(macstring);
     //lcd.print(macstring);
     //delay(10000);
     //report.print("&");
     //report.print("lux");
     //report.print("=");
     report.print(Light_Intensity);
     report.print("&itmp=");
     report.print(readTemp());
     report.println(" HTTP/1.1");
     report.println("Host: 192.168.0.113:82");
     report.println("User-Agent: arduino_mega/1.0.1");
	//report.println(Ethernet.localIP());
     report.println("Connection: close");
     report.println();
    
     // send the packet - this also releases all stash buffers once done
     }
   }
   
   if(chas>23)//если переменная час больше 23 ...
   {
     chas=0;//сбрасываем ее на 0
    
   }
   if(chas == 7)
   {
     light=map(sek+min, 0, 120, 0, 255);
     analogWrite(10, light); 
   }
   else if(chas > 7 && chas < 21)
   {
     light=255;
     digitalWrite(9, HIGH);
     analogWrite(10, light); 
   }
   else if(chas == 21)
   {
     light=255-map(sek+min, 0, 120, 0, 255);
     analogWrite(10, light); 
   }
   else if(chas > 21 || chas < 6)
   {
     light=0;
     digitalWrite(9, LOW);
     analogWrite(10, light); 
   }
   //вывод символов на дисплей//
   
   lcd.setCursor(0+zd, 1);//выводим значение часов в строку - 1
   //столбец -4 
   if(chas<10) {
    lcd.print(0);//количество часов 
   }
   lcd.print(chas);//количество часов
   
   lcd.setCursor(3+zd, 1);//выводим значение часов в строку - 1
   //столбец -7 
   if(min<10) {
    lcd.print(0);//количество часов 
   }
   lcd.print(min);//количество минут
   
   lcd.setCursor(6+zd, 1);//выводим значение часов в строку - 1
   //столбец -10 
   if(sek<10) {
    lcd.print(0);//количество часов 
   }
   lcd.print(sek);//количество секунд
   
   
 } 
 
 
      //установка времени//
          //кнопка//
 
 
   
   /*if(digitalRead(8)==HIGH&&knopka==0)//если кнопка нажата 
   // и перемення "knopka" равна 0 , то ...
   {
      min++;//пишем + 1 в переменную минута
      sek=0;//пишем 0 в переменную секунда
      knopka++;//пишем 1 в переменную кнопка
      //это нужно для того что бы с каждым нажатием кнопки
      //происходило только одно действие
      // плюс защита от "дребезга"
      
      
      
      //с каждым нажатием кнопки обновляем значения на дисплее//
      lcd.setCursor(4, 1);
   lcd.print(chas);
   
   lcd.setCursor(7, 1);
   lcd.print(min);
   
   lcd.setCursor(10, 1);
   lcd.print(sek);
   }
   
    if(digitalRead(8)==LOW&&knopka==1)//если кнопка НЕ нажата
   //и переменная knopka равна - 1 ,то ...
   {
      
      knopka=0;//обнуляем переменную "knopka"
   }
   */
 
 //выводим надпись "CHASI." в строку - 0 
 //lcd.setCursor(0+zd, 1);
 //lcd.print("TIME ");
 
 
}

unsigned long sendNTPpacket(IPAddress& address)
{
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE); 
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49; 
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;

  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp: 		   
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer,NTP_PACKET_SIZE);
  Udp.endPacket(); 
}


long readTemp() {
  long result;
  // Read temperature sensor against 1.1V reference
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = (result - 125) * 1075;
  return result;
}
